package org.fossasia.phimpme.editor;

import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import com.nostra13.universalimageloader.cache.disc.impl.UnlimitedDiskCache;
import com.nostra13.universalimageloader.cache.disc.naming.HashCodeFileNameGenerator;
import com.nostra13.universalimageloader.cache.memory.impl.LruMemoryCache;
import com.nostra13.universalimageloader.core.DisplayImageOptions;
import com.nostra13.universalimageloader.core.ImageLoader;
import com.nostra13.universalimageloader.core.ImageLoaderConfiguration;
import com.nostra13.universalimageloader.core.assist.QueueProcessingType;
import com.nostra13.universalimageloader.core.decode.BaseImageDecoder;
import com.nostra13.universalimageloader.core.download.BaseImageDownloader;
import java.io.File;
import org.fossasia.phimpme.base.ThemedActivity;

public class EditBaseActivity extends ThemedActivity {

  protected void checkInitImageLoader() {
    if (!ImageLoader.getInstance().isInited()) {
      initImageLoader();
    } // end if
  }

  private void initImageLoader() {
    File cacheDir = com.nostra13.universalimageloader.utils.StorageUtils.getCacheDirectory(this);
    int MAXMEMONRY = (int) (Runtime.getRuntime().maxMemory());
    // System.out.println("dsa-->"+MAXMEMONRY+"   "+(MAXMEMONRY/5));//.memoryCache(new
    // LruMemoryCache(50 * 1024 * 1024))
    DisplayImageOptions defaultOptions =
        new DisplayImageOptions.Builder().cacheInMemory(true).cacheOnDisk(true).build();
    ImageLoaderConfiguration config =
        new ImageLoaderConfiguration.Builder(this)
            .memoryCacheExtraOptions(480, 800)
            .defaultDisplayImageOptions(defaultOptions)
            .diskCacheExtraOptions(480, 800, null)
            .threadPoolSize(3)
            .threadPriority(Thread.NORM_PRIORITY - 2)
            .tasksProcessingOrder(QueueProcessingType.FIFO)
            .denyCacheImageMultipleSizesInMemory()
            .memoryCache(new LruMemoryCache(MAXMEMONRY / 5))
            .diskCache(new UnlimitedDiskCache(cacheDir))
            .diskCacheFileNameGenerator(new HashCodeFileNameGenerator()) // default
            .imageDownloader(new BaseImageDownloader(this)) // default
            .imageDecoder(new BaseImageDecoder(false)) // default
            .defaultDisplayImageOptions(DisplayImageOptions.createSimple())
            .build();

    ImageLoader.getInstance().init(config);
  }

  public static Dialog getLoadingDialog(Context context, int titleId, boolean canCancel) {
    return getLoadingDialog(context, context.getString(titleId), canCancel);
  }

  public static Dialog getLoadingDialog(Context context, String title, boolean canCancel) {
    ProgressDialog dialog = new ProgressDialog(context);
    dialog.setCancelable(canCancel);
    dialog.setMessage(title);
    return dialog;
  }
}
